'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbEncrypt.exe"
#Dim All
#Debug Error On
#Debug Display On
#Include "Win32API.inc"
#Include "CommCtrl.inc"

#Resource Icon, aaa, "files\key.ico"
#Resource Icon, xNew, "files\new.ico"
#Resource Icon, xOpen, "files\open.ico"
#Resource Icon, xSave, "files\saveb.ico"
#Resource Icon, xSettings, "files\settings.ico"
#Resource Icon, xGraySave, "files\graysave.ico"
#Resource Icon, xSaveAs, "files\save.ico"
#Resource Icon, xHelp, "files\help.ico"
#Resource Icon, xAutoSave, "files\autosave.ico"
#Resource Icon, xCut, "files\cut.ico"
#Resource Icon, xCopy, "files\copy.ico"
#Resource Icon, xPaste, "files\paste.ico"
#Resource Icon, xDelete, "files\delete.ico"
#Resource Icon, xFind, "files\find.ico"
#Resource Icon, xFont, "files\font.ico"
#Resource Icon, xRedo, "files\redo.ico"
#Resource Icon, xUndo, "files\undo.ico"
#Resource Icon, xRedog, "files\redogray.ico"
#Resource Icon, xUndog, "files\undogray.ico"

Type CustomColors
   c(15) As Long
End Type

$Ver = " 1.31 "
$Key = "Encrypted"

$CLSID_ShellLink = Guid$("{00021401-0000-0000-C000-000000000046}")
'$IID_IShellLink = Guid$("{000214EE-0000-0000-C000-000000000046}")
$IID_IPersistFile = Guid$("{0000010B-0000-0000-C000-000000000046}")

Declare Function Sub1( p1 As Any ) As Dword
Declare Function Sub2( p1 As Any, p2 As Any ) As Dword
Declare Function Sub3( p1 As Any, p2 As Any, p3 As Any ) As Dword
Declare Function Sub5( p1 As Any, p2 As Any, p3 As Any, p4 As Any, p5 As Any ) As Dword

%IDC_Toolbar    = 501
%IDC_Content    = 502

%IDC_Search      = 550
%IDC_Replace     = 551
%IDC_SearchTerm  = 552
%IDC_ReplaceTerm = 553
%IDC_Up          = 554
%IDC_Down        = 555
%IDC_MatchCase   = 556

%IDT_New        = 600
%IDT_Open       = 601
%IDT_Save       = 602
%IDT_SaveAs     = 603
%IDT_Encrypt    = 604
%IDT_AutoSave   = 605
%IDT_Help       = 606
%IDT_Cut        = 607
%IDT_Copy       = 608
%IDT_Paste      = 609
%IDT_Delete     = 610
%IDT_Font       = 611
%IDT_Settings   = 612
%IDT_Undo       = 613
%IDT_Redo       = 614

%IDM_CutContent     = 701
%IDM_CopyContent    = 702
%IDM_PasteContent   = 703
%IDM_DeleteContent  = 704
%IDM_OpenFolder     = 705
%IDM_SelectAll      = 706
%IDM_CopyAll        = 707
%IDM_ExtList        = 708
%IDM_Search         = 709
%IDM_InsertTime     = 710

%IDM_NumberRequired  = 750
%IDM_CapitalRequired = 751
%IDM_NoSpaces        = 752
%IDM_MinCharacters   = 753
%IDM_SetMinCharCount = 754
%IDM_Sep             = 755
%IDM_HidePassword    = 756
%IDM_Debug           = 757
%IDM_ClearConsole    = 758
%IDM_Reload          = 759

%IDM_SortAscending   = 800
%IDM_SortDescending  = 801
%IDM_MatchingLines   = 802
%IDM_UpperCase       = 803
%IDM_LowerCase       = 804
%IDM_ContentSummary  = 805
%IDM_FGColor         = 806
%IDM_BGColor         = 807
%IDM_GoTo            = 808
%IDM_Number          = 809
%IDM_UnNumber        = 810
%IDM_AutoSave        = 811
%IDM_MinToolbar      = 812

Global hDlg,hToolbar,hImageListEnabled,hImageListDisabled,hContextContent,hPopupSettings As Dword
Global ghHook,hContent,hPopupContent,hHook,hPopupEncrypt,hPopupActions,hConsole,hSearch,hFont As Dword
Global Encrypt, Changes, OldProcContent, AutoSave, Changes, fDlgShown As Long, CustomColorList As CustomColors
Global CFN, psw, ExtList,SearchTerm,ReplaceTerm,FontName As String, FontSize, FontStyle As Long
Global pswHidePassword ,pswMinCharacterCount, pswMinCharacters, Debug, FGColor, BGColor As Long
Global pswNumberRequired, pswCapitalRequired, pswNoSpaces, WrapLines, minToolbar As Long

Function PBMain() As Long
   Dialog New Pixels, 0, "gbEncrypt",300,300,400,300, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "aaa"
   CreateImageLists          'enabled and disabled imagelists
   Control Add TextBox, hDlg, %IDC_Content,"Content", 0,50,200,200, %WS_TabStop Or %WS_Border Or  %ES_Left Or %ES_AutoHScroll Or %ES_AutoVScroll Or %ES_MultiLine Or %ES_NoHideSel Or %ES_WantReturn Or %WS_HScroll Or %WS_VScroll, %WS_Ex_ClientEdge
   SubClassControls   'also create custom context menu
   DragAcceptFiles hDlg, %True
   Dialog Show Modal hDlg Call DlgProc
End Function

CallBack Function DlgProc() As Long
   Local iResult,x,y,w,h As Long, temp$, nmtb As TBnotify Ptr, rc As Rect
   Select Case Cb.Msg
       Case %WM_InitDialog
           BuildAcceleratorTable
           Control Send hDlg, %IDC_Content, %EM_FmtLines, %True, 0
           Settings_INI "get"
           Dialog Get Size hDlg To w,h
           CreateToolbar w
           CreateContentFont
           Control Set Color hDlg, %IDC_Content, FGColor, BGColor
           If IsFalse(IsFile(CFN)) Then
               'previous session file name is invalid or CFN="" on 1st-time startup
               If Len(CFN) Then MsgBoxX("File not found: " + $CrLf + $CrLf + CFN + $CrLf + $CrLf + "New file will be created.", %MB_Ok + %MB_IconInformation, "Open File")
               CFN = CreateNewFile : Encrypt = 0  'unencrypted
           ElseIf ProvideOpenFilePassword(CFN) = 0 Then
               'valid file name, but user did not supply correct password, so create/open new CFN
               MsgBoxX("Invalid password. New file created.", %MB_Ok + %MB_IconInformation, "Open File")
               CFN = CreateNewFile : Encrypt = 0
           End If
           LoadCFN    'sets Changes=0, puts CFN in dialog caption

       Case %WM_Command
           Select Case Cb.Ctl

               Case %IDC_Content
                  If Cb.CtlMsg = %EN_Change Then
                      Changes = 1 : SetMenusAndToolbarButtons
                  End If

               Case %IDT_New
                   If Changes Then
                      If AutoSave Then
                          If Encrypt Then
                              If ProvideSaveFilePassword Then
                                  SaveContentToCFN : CFN = CreateNewFile : Encrypt = 0 : LoadCFN
                              Else
                                  MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " New File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "New File")
                              End If
                          Else
                              SaveContentToCFN : CFN = CreateNewFile : Encrypt = 0 : LoadCFN
                          End If
                      Else
                          Select Case MsgBoxX("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "New File")
                             Case %IdYes
                                 If Encrypt Then
                                     If ProvideSaveFilePassword Then
                                         SaveContentToCFN : CFN = CreateNewFile : Encrypt = 0 : LoadCFN
                                     Else
                                         MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " New File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "New File")
                                     End If
                                 Else
                                     SaveContentToCFN : CFN = CreateNewFile : Encrypt = 0 : LoadCFN
                                 End If
                             Case %IdNo     : CFN = CreateNewFile : Encrypt = 0 : LoadCFN   'no save
                             Case %IdCancel    'no save and no new
                          End Select
                      End If
                   Else
                       CFN = CreateNewFile : Encrypt = 0 : LoadCFN
                   End If
                   Dialog Set Text hDlg, "gbEncrypt" + $ver + Space$(5) + CFN
                   SetMenusAndToolbarButtons       'not always required, but doesn't hurt to run when not needed

               Case %IDT_Open
                   If Changes Then
                      If AutoSave Then
                          If Encrypt Then
                              If ProvideSaveFilePassword Then
                                  SaveContentToCFN : iResult = 1
                              Else
                                  MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " Open File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Open File")
                              End If
                          Else
                              SaveContentToCFN : iResult = 1   'save change, then open file below
                          End If
                      Else
                          Select Case MsgBoxX("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Open File")
                             Case %IdYes
                                 If Encrypt Then
                                     If ProvideSaveFilePassword Then
                                         SaveContentToCFN : iResult = 1  'save change, then open file below
                                     Else
                                          MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " Open File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Open File")
                                     End If
                                 Else
                                     SaveContentToCFN : iResult = 1  'save change, then open file below
                                 End If
                             Case %IdNo     : iResult = 1  'no save changes, then open file below
                             Case %IdCancel : iResult = 0  'no further action
                          End Select
                      End If
                   Else
                      iResult = 1   'open file below
                   End If

                   If iResult Then
                       'select file to open, ask for password, and open the file
                       temp$ = SelectFileToOpen
                       If Len(temp$) Then
                           If ProvideOpenFilePassword(temp$) Then
                               CFN = temp$ : LoadCFN      'user gave correct password
                           Else
                               MsgBoxX("Password not provided. Selected file will not be opened!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Select File")  'user did not give correct password
                           End If
                       End If
                   End If
                   Dialog Set Text hDlg, "gbEncrypt" + $ver + Space$(5) + CFN
                   SetMenusAndToolbarButtons       'not always required, but doesn't hurt to run when not needed

               Case %IDT_Save
                   'saves even if no changes, but must provide password if encrypt is enabled
                   '%IDT_Save toolbar button is disabled if no changes, but this code can be called if needed
                   If Encrypt Then
                       If ProvideSaveFilePassword Then
                           SaveContentToCFN
                       Else
                           'was cancelled (no password provided)
                           'MsgBoxX("Password not provided. File was not saved!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Select File")  'user did not give correct password
                       End If
                   Else
                       SaveContentToCFN
                   End If

               Case %IDT_SaveAs
                   temp$ = SelectSaveAsFileName     'temp$ = chosen file name
                   If Len(temp$) Then
                       If Encrypt Then
                           If ProvideSaveFilePassword Then
                               CFN = temp$ : SaveContentToCFN
                           Else
                               MsgBoxX("Password not provided. File was not saved!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Select File")  'user did not give correct password
                           End If
                       Else
                           CFN = temp$ : SaveContentToCFN
                       End If
                       Dialog Set Text hDlg, "gbEncrypt" + $ver + Space$(5) + CFN
                       SetMenusAndToolbarButtons       'not always required, but doesn't hurt to run when not needed
                   Else
                       'was cancelled (no SaveAs file name selected)
                   End If
               Case %IDT_Redo      : Redo
               Case %IDT_Undo      : Undo

               Case %IDM_InsertTime
                   temp$ = Date$ + " " + Time$
                   Control Send hDlg, %IDC_Content, %EM_ReplaceSel, %True, StrPtr(temp$)
               Case %IDM_ExtList   : GetExtList
               Case %IDM_SelectAll : Control Send hDlg, %IDC_Content, %EM_SetSel, 0, -1
               Case %IDM_CopyAll
                   Control Get Text hDlg, %IDC_Content To temp$
                   Clipboard Reset
                   Clipboard Set Text temp$

               Case %IDT_Font       : SelectContentFont
               Case %IDM_MinToolbar
                   minToolbar Xor = 1 : Control Kill hDlg, %IDC_Toolbar
                   CreateToolbar IIf(minToolbar, 420,660) : SetMenusAndToolbarButtons
               Case %IDT_Encrypt    : Encrypt  Xor = 1    : Changes = 1 : SetMenusAndToolbarButtons
               Case %IDT_AutoSave, %IDM_AutoSave : AutoSave Xor = 1  : SetMenusAndToolbarButtons

               Case %IDM_CutContent, %IDT_Cut       : SendMessage hContent, %WM_CUT, 0, 0
               Case %IDM_CopyContent, %IDT_Copy     : SendMessage hContent, %WM_COPY, 0, 0
               Case %IDM_PasteContent, %IDT_Paste   : SendMessage hContent, %WM_PASTE, 0, 0
               Case %IDM_DeleteContent, %IDT_Delete : SendMessage hContent, %WM_CLEAR, 0, 0
               Case %IDM_OpenFolder
                   iResult = ShellExecute(hDlg, "Open", Trim$(PathName$(Path,CFN)), $Nul, $Nul, %SW_ShowNormal)
               Case %IDM_HidePassword    : pswHidePassword Xor = 1    : SetMenusAndToolbarButtons
               Case %IDM_MinCharacters   : pswMinCharacters Xor = 1   : SetMenusAndToolbarButtons
               Case %IDM_CapitalRequired : pswCapitalRequired Xor = 1 : SetMenusAndToolbarButtons
               Case %IDM_NumberRequired  : pswNumberRequired Xor = 1  : SetMenusAndToolbarButtons
               Case %IDM_NoSpaces        : pswNoSpaces Xor = 1        : SetMenusAndToolbarButtons
               Case %IDM_SetMinCharCount
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
                  CenterOverDialog(300,90,x,y)
                  temp$ = InputBox$("Enter minimum characters:", "Password Character Count", Trim$(Str$(pswMinCharacterCount)),x,y)
                  If Len(temp$) Then
                      If Val(temp$) > 0 Then pswMinCharacterCount = Val(temp$)
                      If Val(temp$) > 50 Then pswMinCharacterCount = Val(temp$)
                      SetMenusAndToolbarButtons
                  End If

               Case %IDM_Debug
                  Debug = Debug Xor 1
                  If Debug Then
                     cPrint "Console Display Enabled" + $CrLf + String$(30,"=")
                  Else
                     FreeConsole
                     hConsole = 0
                  End If
               Case %IDM_ClearConsole : ClearConsole

               Case %IDT_Help
                   temp$ = "http://www.garybeene.com/sw/gbencrypt.htm"
                   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
               Case %IDM_Search : If fDlgShown=0 Then DisplayFindDialog

               Case %IDM_SortAscending  : SortContent "A"
               Case %IDM_SortDescending : SortContent "D"
               Case %IDM_UpperCase
                   Control Get Text hDlg, %IDC_Content To temp$
                   Control Set Text hDlg, %IDC_Content, UCase$(temp$)
               Case %IDM_LowerCase
                   Control Get Text hDlg, %IDC_Content To temp$
                   Control Set Text hDlg, %IDC_Content, LCase$(temp$)
               Case %IDM_MatchingLines  : DisplayMatchingLines
               Case %IDM_ContentSummary : ContentSummary
               Case %IDM_FGColor
                   FGColor = SelectColor(FGColor)
                   Control Set Color hDlg, %IDC_Content, FGColor, BGColor
                   Control ReDraw hDlg, %IDC_Content
               Case %IDM_BGColor
                   BGColor = SelectColor(BGColor)
                   Control Set Color hDlg, %IDC_Content, FGColor, BGColor
                   Control ReDraw hDlg, %IDC_Content
               Case %IDM_Reload
                   If ProvideOpenFilePassword(CFN) Then
                       LoadCFN      'user gave correct password
                   Else
                       MsgBoxX("Password not provided. Selected file will not be opened!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Reload File")  'user did not give correct password
                   End If
               Case %IDM_GoTo : GoToLine
               Case %IDM_Number   : AddLineNumbers
               Case %IDM_UnNumber : RemoveLineNumbers
           End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Encrypt
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpEncrypt, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopUpActions, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %NULL)
                 End Select
           End Select

      Case %WM_DropFiles
          temp$ = GetDroppedFileName(Cb.WParam)
          DragFinish Cb.WParam
          OpenDroppedFile temp$


      Case %WM_Size
          Dialog Get Client hDlg To w,h
          Control Set Size hDlg, %IDC_Content, w, h-50

      Case %WM_SYSCOMMAND
          If ((Cb.WParam And &HFFF0) = %SC_Close) Then    'trap Alt-F4, X-button, WindowMenu/Close
              If Changes Then
                 If AutoSave Then
                     If Encrypt Then
                         If ProvideSaveFilePassword Then
                             SaveContentToCFN
                         Else
                             MsgBoxX("Invalid password, application will not close!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Exit Application")
                             Function = 1  'abort the clsoe
                         End If
                     Else
                         SaveContentToCFN
                     End If
                 Else
                     Select Case MsgBoxX("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Exit Application")
                        Case %IdYes
                            If Encrypt Then
                                If ProvideSaveFilePassword Then
                                    SaveContentToCFN
                                Else
                                    MsgBoxX("Invalid password, application will not close!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Exit Application")
                                    Function = 1  'abort the close
                                End If
                            Else
                                SaveContentToCFN
                            End If
                        Case %IdNo     'no save
                        Case %IdCancel : Function = 1   'no save, abort the close
                     End Select
                 End If
              End If
          End If

      Case %WM_Destroy
         Settings_INI "save"
         SetWindowLong hContent, %GWL_WNDPROC, OldProcContent   'un-subclass
   End Select
End Function

'Open      Changes-Y  -----  AutoSave-Y   --------------------  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN  --  SelectFileName/AskPSW/Load
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN  --  SelectFileName/AskPSW/Load
'
'                            AutoSave-N  ----- AskSAVE-Y  ----  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN  --  SelectFileName/AskPSW/Load
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN  --  SelectFileName/AskPSW/Load
'                                              AskSAVE-N  ----------------------------------------------------  SelectFileName/AskPSW/Load
'                                              AskSAVE-C  ----  X
'          Changes-N  ----------------------------------------------------------------------------------------  SelectFileName/AskPSW/Load

'New       Changes-Y  -----  AutoSave-Y   --------------------  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN  --  CreateNewFile/Load
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN  --  CreateNewFile/Load
'
'                            AutoSave-N  ----- AskSAVE-Y  ----  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN  --  CreateNewFile/Load
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN  --  CreateNewFile/Load
'                                              AskSAVE-N  ----------------------------------------------------  CreateNewFile/Load
'                                              AskSAVE-C  ----  X
'          Changes-N  ----------------------------------------------------------------------------------------  CreateNewFile/Load

'Save      --- forced Save -----------------------------------  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN

'SaveAs    --- selectfilename --------------------------------  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN


'Exit      Changes-Y  -----  AutoSave-Y   --------------------  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN
'
'                            AutoSave-N  ----- AskSAVE-Y  ----  Encrypt-Y  ------  AskPSW-Y  ----  SaveCFN
'                                                                                  AskPSW-N  ----  X
'                                                               Encrypt-N  ----------------------  SaveCFN
'                                              AskSAVE-N  ----  X
'                                              AskSAVE-C  ----  X (abort close)
'          Changes-N  ----  X

Function ProvideSaveFilePassword() As Long
    If Debug Then cPrint LCase$(FuncName$)
    'return 1=acceptable password entered  0=cancel operation
    Local x,y As Long, temp$, msg$
    CenterOverDialog(300,90,x,y)
    msg$ = "Enter password (save):" : temp$ = psw
    Do
        ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
        temp$ = InputBox$(msg$, "Enter Password","",x,y)   'no leading/trailing spaces
        If Len(temp$) = 0 Then
            msg$ = "" : Function = 0   'cancel
        ElseIf pswMinCharacters And (Len(temp$) < pswMinCharacterCount) Then
            msg$ = "Re-Enter ("+ Trim$(Str$(pswMinCharacterCount)) + " char min):"
        ElseIf pswNumberRequired And InStr(temp$, Any "0123456789") = 0 Then
            msg$ = "Re-Enter (min 1 number):"
        ElseIf pswCapitalRequired And InStr(temp$, Any Chr$(65 To 90)) = 0 Then
            msg$ = "Re-Enter (min 1 capital letter):"
        ElseIf pswNoSpaces And InStr(temp$, " ") Then
            msg$ = "Re-Enter (no spaces):"
        Else
            psw = temp$ : msg$ = "" : Function = 1  'password accepted
        End If
    Loop While Len(msg$)
End Function

Sub SaveContentToCFN
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$
    If Encrypt Then
        Control Get Text hDlg, %IDC_Content To temp$
        Open CFN For Output As #1
        Print #1, $Nul; EncryptText($Key,psw);
        Print #1, EncryptText(temp$,psw);
        Close #1
    Else
        Control Get Text hDlg, %IDC_Content To temp$
        Open CFN For Output As #1
        Print #1, temp$;
        Close #1
    End If
    Changes = 0 : SetMenusAndToolbarButtons
End Sub

Sub CreateImageLists
    ImageList New Icon 24,24,24,10 To hImageListEnabled
    ImageList Add Icon hImageListEnabled, "xsave"        '1
    ImageList Add Icon hImageListEnabled, "xopen"        '2
    ImageList Add Icon hImageListEnabled, "xnew"         '3
    ImageList Add Icon hImageListEnabled, "aaa"          '4
    ImageList Add Icon hImageListEnabled, "xsettings"    '5
    ImageList Add Icon hImageListEnabled, "xsaveas"      '6
    ImageList Add Icon hImageListEnabled, "xhelp"        '7
    ImageList Add Icon hImageListEnabled, "xautosave"    '8
    ImageList Add Icon hImageListEnabled, "xcut"         '9
    ImageList Add Icon hImageListEnabled, "xcopy"        '10
    ImageList Add Icon hImageListEnabled, "xpaste"       '11
    ImageList Add Icon hImageListEnabled, "xdelete"      '12
    ImageList Add Icon hImageListEnabled, "xfind"        '13
    ImageList Add Icon hImageListEnabled, "xfont"        '14
    ImageList Add Icon hImageListEnabled, "xredo"        '15
    ImageList Add Icon hImageListEnabled, "xundo"        '16

    ImageList New Icon 24,24,24,10 To hImageListDisabled
    ImageList Add Icon hImageListDisabled, "xgraysave"   '1
    ImageList Add Icon hImageListDisabled, "xopen"       '2
    ImageList Add Icon hImageListDisabled, "xnew"        '3
    ImageList Add Icon hImageListDisabled, "aaa"         '4
    ImageList Add Icon hImageListDisabled, "xsettings"   '5
    ImageList Add Icon hImageListDisabled, "xsaveas"     '6
    ImageList Add Icon hImageListDisabled, "xhelp"       '7
    ImageList Add Icon hImageListDisabled, "xautosave"   '8
    ImageList Add Icon hImageListDisabled, "xcut"        '9
    ImageList Add Icon hImageListDisabled, "xcopy"       '10
    ImageList Add Icon hImageListDisabled, "xpaste"      '11
    ImageList Add Icon hImageListDisabled, "xdelete"     '12
    ImageList Add Icon hImageListDisabled, "xfind"       '13
    ImageList Add Icon hImageListDisabled, "xfont"       '14
    ImageList Add Icon hImageListDisabled, "xredog"      '15
    ImageList Add Icon hImageListDisabled, "xundog"      '16
End Sub

Sub CreateToolbar(wNew As Long)
    If Debug Then cPrint LCase$(FuncName$)
    Local w,h As Long
    Dialog Get Size hDlg To w,h
    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SetExtendedStyle, 0, %TBStyle_EX_DrawDDArrows
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListEnabled, 0     'default imagelist
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListDisabled, 1    'disabled images

    If minToolbar Then
        Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_New,  %TbStyle_Button, "New"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Open,  %TbStyle_Button, "Open"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Save,  %TbStyle_Button, "Save"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_SaveAs,  %TbStyle_Button, "Save As"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDM_Search,  %TbStyle_Button, "Find"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Encrypt,  %TbStyle_Check Or %TbStyle_DropDown, "Encrypt"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Actions"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Help,  %TbStyle_Button, "Help"
        Dialog Set Size hDlg, wNew,h
    Else
        Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_New,  %TbStyle_Button, "New"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Open,  %TbStyle_Button, "Open"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Save,  %TbStyle_Button, "Save"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_SaveAs,  %TbStyle_Button, "Save As"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Cut,  %TbStyle_Button, "Cut"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Copy,  %TbStyle_Button, "Copy"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_Paste,  %TbStyle_Button, "Paste"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Delete,  %TbStyle_Button, "Delete"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDM_Search,  %TbStyle_Button, "Find"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_Encrypt,  %TbStyle_Check Or %TbStyle_DropDown, "Encrypt"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Font,  %TbStyle_Button, "Font"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_AutoSave,  %TbStyle_Check, "AutoSave"
        Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Actions"
        Toolbar Add Separator hDlg, %IDC_Toolbar, 20
        Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Help,  %TbStyle_Button, "Help"
        Dialog Set Size hDlg, wNew,h
    End If

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "AutoSave", %IDM_AutoSave, %MF_Enabled
'    Menu Add String, hPopupSettings, "Minimal Toolbar", %IDM_MinToolbar, %MF_Enabled

    Menu New PopUp To hPopupEncrypt
    Menu Add String, hPopupEncrypt, "Minimum Characters Required", %IDM_MinCharacters, %MF_Enabled
    Menu Add String, hPopupEncrypt, "At Least 1 Number Required", %IDM_NumberRequired, %MF_Enabled
    Menu Add String, hPopupEncrypt, "Capital Letter Required", %IDM_CapitalRequired, %MF_Enabled
    Menu Add String, hPopupEncrypt, "No Spaces Allowed", %IDM_NoSpaces, %MF_Enabled
    Menu Add String, hPopupEncrypt, "Hide Password", %IDM_HidePassword, %MF_Enabled
    Menu Add String, hPopupEncrypt, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupEncrypt, "Set Minimum Characters (0)", %IDM_SetMinCharCount, %MF_Enabled

    Menu New PopUp To hPopupActions
    Menu Add String, hPopupActions, "Show Content Summary", %IDM_ContentSummary, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Sort Ascending", %IDM_SortAscending, %MF_Enabled
    Menu Add String, hPopupActions, "Sort Descending", %IDM_SortDescending, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Upper Case", %IDM_UpperCase, %MF_Enabled
    Menu Add String, hPopupActions, "Lower Case", %IDM_LowerCase, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Add Line Numbers", %IDM_Number, %MF_Enabled
    Menu Add String, hPopupActions, "Remove Line Numbers", %IDM_UnNumber, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Select Font", %IDT_Font, %MF_Enabled
    Menu Add String, hPopupActions, "Select FG Color", %IDM_FGColor, %MF_Enabled
    Menu Add String, hPopupActions, "Select BG Color", %IDM_BGColor, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupActions, "Show Matching Lines", %IDM_MatchingLines, %MF_Enabled
    Menu Add String, hPopupActions, "-", %IDM_Sep, %MF_Enabled
    Menu Add PopUp, hPopupActions, "Settings", hPopupSettings, %MFS_Enabled
End Sub

Sub Settings_INI(Task$)
   If Debug Then cPrint LCase$(FuncName$)
   Local i,x,y As Long
   Local xResult, yResult, tempz, INIFileName As AsciiZ * %Max_Path

   'set ini filename
   INIFileName = Exe.Path$ + "gbEncrypt.ini"

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "400", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "400", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "660", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "250", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get value for string variables
      GetPrivateProfileString "All", "CFN", "", tempz, %Max_Path, INIFileName
      CFN = LCase$(tempz)

      GetPrivateProfileString "All", "ExtList", "*.txt", tempz, %Max_Path, INIFileName
      ExtList = LCase$(tempz)

      GetPrivateProfileString "All", "SearchTerm", "", tempz, %Max_Path, INIFileName
      SearchTerm = LCase$(tempz)

      GetPrivateProfileString "All", "ReplaceTerm", "", tempz, %Max_Path, INIFileName
      ReplaceTerm = LCase$(tempz)

      GetPrivateProfileString "All", "FontName", "MS Sans Serif", tempz, %Max_Path, INIFileName
      FontName = LCase$(tempz)

      'get value for numeric variables
      Getprivateprofilestring "All", "Encrypt", "0", tempz, %Max_Path, INIFileName
      Encrypt = Val(tempz)

      Getprivateprofilestring "All", "AutoSave", "0", tempz, %Max_Path, INIFileName
      AutoSave = Val(tempz)

      Getprivateprofilestring "All", "pswHidePassword", "0", tempz, %Max_Path, INIFileName
      pswHidePassword = Val(tempz)

      Getprivateprofilestring "All", "pswNumberRequired", "0", tempz, %Max_Path, INIFileName
      pswNumberRequired = Val(tempz)

      Getprivateprofilestring "All", "pswCapitalRequired", "0", tempz, %Max_Path, INIFileName
      pswCapitalRequired = Val(tempz)

      Getprivateprofilestring "All", "pswNoSpaces", "0", tempz, %Max_Path, INIFileName
      pswNoSpaces = Val(tempz)

      Getprivateprofilestring "All", "pswMinCharacters", "0", tempz, %Max_Path, INIFileName
      pswMinCharacters = Val(tempz)

      Getprivateprofilestring "All", "pswMinCharacterCount", "5", tempz, %Max_Path, INIFileName
      pswMinCharacterCount = Val(tempz)

      Getprivateprofilestring "All", "FontSize", "8", tempz, %Max_Path, INIFileName
      FontSize = Val(tempz)

      Getprivateprofilestring "All", "FontStyle", "0", tempz, %Max_Path, INIFileName
      FontStyle = Val(tempz)

      Getprivateprofilestring "All", "FGColor", Str$(%Black), tempz, %Max_Path, INIFileName
      FGColor = Val(tempz)

      Getprivateprofilestring "All", "BGColor", Str$(%White), tempz, %Max_Path, INIFileName
      BGColor = Val(tempz)

      Getprivateprofilestring "All", "minToolbar", "0", tempz, %Max_Path, INIFileName
      minToolbar = Val(tempz)

      For i = 0 To 15
         Getprivateprofilestring "Custom", "CustomColor" + Format$(i,"00"), "", tempz, %Max_Path, INIFileName
         CustomColorList.c(i) = Val(tempz)
      Next i

   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "CFN", (CFN), INIFileName
      WritePrivateProfileString "All", "ExtList", (ExtList), INIFileName
      WritePrivateProfileString "All", "SearchTerm", (SearchTerm), INIFileName
      WritePrivateProfileString "All", "ReplaceTerm", (ReplaceTerm), INIFileName
      WritePrivateProfileString "All", "FontName", (FontName), INIFileName
'      'save numeric variables
      WritePrivateProfileString "All", "Encrypt", (Str$(Encrypt)), INIFileName
      WritePrivateProfileString "All", "AutoSave", (Str$(AutoSave)), INIFileName
      WritePrivateProfileString "All", "pswHidePassword", (Str$(pswHidePassword)), INIFileName
      WritePrivateProfileString "All", "pswNumberRequired", (Str$(pswNumberRequired)), INIFileName
      WritePrivateProfileString "All", "pswCapitalRequired", (Str$(pswCapitalRequired)), INIFileName
      WritePrivateProfileString "All", "pswNoSpaces", (Str$(pswNoSpaces)), INIFileName
      WritePrivateProfileString "All", "pswMinCharacters", (Str$(pswMinCharacters)), INIFileName
      WritePrivateProfileString "All", "pswMinCharacterCount", (Str$(pswMinCharacterCount)), INIFileName
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontStyle", (Str$(FontStyle)), INIFileName
      WritePrivateProfileString "All", "FGColor", (Str$(FGColor)), INIFileName
      WritePrivateProfileString "All", "BGColor", (Str$(BGColor)), INIFileName
      WritePrivateProfileString "All", "minToolbar", (Str$(minToolbar)), INIFileName

      For i = 0 To 15
         tempz = Str$(CustomColorList.c(i))
         WritePrivateProfileString "Custom", "CustomColor" + Format$(i,"00"), tempz, INIFileName
      Next i

   End If
End Sub

Function SelectFileToOpen() As String
   If Debug Then cPrint LCase$(FuncName$)
   Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
   title$ = "Open File"
   filter$ = "Text Files  (" + ExtList + ")"  + $Nul + ExtList + $Nul
   startfolder$ = CFN
   startfile$ = CFN
   defaultext$ = "txt"
   flags& = %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly
   Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
   Function = filevar$
End Function

Function SelectSaveAsFileName() As String
    If Debug Then cPrint LCase$(FuncName$)
    'save file to any location
    Local title$, startfolder$, filter$, startfile$, defaultext$, flags&, filevar$, countvar&
    title$ = ""             'caption title. if "", then "Save As" is displayed
    startfolder$ = CFN   'initial folder to be displayed
    filter$ = "Text Files  (" + ExtList + ")"  + $Nul + ExtList + $Nul
    startfile$ = CFN        'name to be used as initial selection
    defaultext$ = "txt"     'default extension to append to selection if user does not enter it
    flags& = %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    Function = filevar$
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   If Debug Then cPrint LCase$(FuncName$)
   hHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then cPrint LCase$(FuncName$)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x,y,ww,hh As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To ww,hh
   CenterX = x + (ww-BoxX)/2
   CenterY = y + (hh-BoxY)/2
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx hHook
   End If
End Function

Sub SubClassControls
   If Debug Then cPrint LCase$(FuncName$)
   Control Handle hDlg, %IDC_Content To hContent
   OldProcContent = SetWindowLong(GetDlgItem(hDlg, %IDC_Content), %GWL_WndProc, CodePtr(NewProcContent))  'subclass

   Menu New PopUp To hContextContent
   Menu Add String, hContextContent, "Cut",  %IDM_CutContent,  %MF_Enabled
   Menu Add String, hContextContent, "Copy",  %IDM_CopyContent,  %MF_Enabled
   Menu Add String, hContextContent, "Paste",  %IDM_PasteContent,  %MF_Enabled
   Menu Add String, hContextContent, "Delete", %IDM_DeleteContent,  %MF_Enabled
   Menu Add String, hContextContent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextContent, "Select All", %IDM_SelectAll,  %MF_Enabled
   Menu Add String, hContextContent, "Copy All", %IDM_CopyAll,  %MF_Enabled
   Menu Add String, hContextContent, "Insert Date/Time", %IDM_InsertTime,  %MF_Enabled
   Menu Add String, hContextContent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextContent, "Reload File (Lose Changes)", %IDM_Reload,  %MF_Enabled
   Menu Add String, hContextContent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextContent, "Open File Location", %IDM_OpenFolder,  %MF_Enabled
   Menu Add String, hContextContent, "-", %IDM_Sep, %MF_Enabled
   Menu Add String, hContextContent, "Toggle Console", %IDM_Debug,  %MF_Enabled
   Menu Add String, hContextContent, "Clear Console", %IDM_ClearConsole,  %MF_Enabled
End Sub

Function NewProcContent(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   'If Debug Then cPrint LCase$(FuncName$)
   Local x As Long, y As Long
   Select Case Msg
      Case %WM_ContextMenu
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextContent, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcContent, hWnd, Msg, wParam, lParam)
End Function

Function ProvideOpenFilePassword(fName$) As Long
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, x,y,iResult As Long
    Open fName$ For Binary As #1
    Get$ #1, 1, temp$   '1 byte, will test for $Nul
    If temp$ = $Nul Then
        'is encrypted
        Get$ #1, Len($Key), temp$ : Close #1
        Encrypt = 1 : SetMenusAndToolbarButtons     'password required
        CenterOverDialog(300,90,x,y)
        Do
           ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
           psw = InputBox$(IIf$(iResult,"Wrong password. Re-Enter:","Enter password:"), "Password","",x,y)
           If psw = ""                      Then Function = 0 : Exit Do
           If EncryptText(temp$,psw) = $Key Then Function = 1 : Exit Do
           iResult = 1   'used in next loop iteration to show "Re-Enter" vs "Enter"
       Loop While Len(psw)
    Else
        Close #1
        Encrypt = 0 : SetMenusAndToolbarButtons : Function = 1  'no password required
    End If

End Function

Function CreateNewFile() As String
    If Debug Then cPrint LCase$(FuncName$)
    Local temp$, NewFileCount As Long
    Do
       Incr NewFileCount
       'create new file in same folder as current CFN, else put in application folder
       temp$ = IIf$(IsFile(CFN),PathName$(Path,CFN),Exe.Path$) + "default_" + Format$(NewFileCount,"000") + ".txt"
    Loop While IsFile(temp$)
    Open temp$ For Output As #1
    Print #1, "<New File>";       'has nothing in front - especially not $Nul + EncryptTest($key,psw) at the front
    Close #1
    Function = temp$
End Function

Sub SetMenusAndToolbarButtons
   If Debug Then cPrint LCase$(FuncName$)
   Local DoSet As Long

   'Toolbar
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(Changes,%TBState_Enabled,%TBState_Disabled)
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Encrypt, %TBState_Checked * Encrypt Or %TBState_Enabled
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_AutoSave, %TBState_Checked * AutoSave Or %TBState_Enabled

   Control Send hDlg, %IDC_Content, %EM_CanUndo, 0, 0 To DoSet
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Redo, IIf(DoSet,%TBState_Enabled,%TBState_Disabled)
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Undo, IIf(DoSet,%TBState_Enabled,%TBState_Disabled)

   'Menus
   Menu Set State hPopupEncrypt,  ByCmd %IDM_NumberRequired, pswNumberRequired * 8
   Menu Set State hPopupEncrypt,  ByCmd %IDM_CapitalRequired, pswCapitalRequired * 8
   Menu Set State hPopupEncrypt,  ByCmd %IDM_NoSpaces, pswNoSpaces * 8
   Menu Set State hPopupEncrypt,  ByCmd %IDM_HidePassword, pswHidePassword * 8    'IIf(pswHidePassword, 8,0)
   Menu Set State hPopupEncrypt,  ByCmd %IDM_MinCharacters, pswMinCharacters * 8  'IIf(pswMinCharacters, 8,0)
   Menu Set Text  hPopupEncrypt,  ByCmd %IDM_SetMinCharCount, "Set Minimum Characters (" + Trim$(Str$(pswMinCharacterCount)) + ")"
   Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * 8
'   Menu Set State hPopupSettings, ByCmd %IDM_MinToolbar, MinToolbar * 8

End Sub

Function EncryptText(text$, Psw$) As String    'Hanlin
   If Debug Then cPrint LCase$(FuncName$)
   Local i,a As Long, temp$
   temp$ = text$
   For i = 1 To Len(text$)
         a = (i Mod Len(Psw$)) + 1        'Joseph Cote
         Asc(temp$,i) = Asc(psw$,a) Xor Asc(temp$,i)
   Next i
   Function = temp$
End Function

Sub LoadCFN
    If Debug Then cPrint LCase$(FuncName$)
    'used once psw, if required, has been entered
    Local temp$, i As Long
    Open CFN For Binary As #1 : Get$ #1, Lof(1), temp$ : Close #1
    If Encrypt Then temp$ = Mid$(temp$,Len($Key)+2)   '$Nul + $key + 1
    Control Set Text hDlg, %IDC_Content, IIf$(Encrypt,EncryptText(temp$,psw), temp$)
    Dialog Set Text hDlg, "gbEncrypt" + $ver + Space$(5) + CFN
    Changes = 0 : SetMenusAndToolbarButtons
End Sub

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "STATIC" Then @cst.cy = 20                           'prompt
        If UCase$(szTemp) = "EDIT"   Then @cst.cx = 190 : @cst.y = @cst.y - 130  'textbox
        If pswHidePassword And (UCase$(szTemp) = "EDIT")   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style) Or %ES_Password
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 130                'dialog
    End If
End Function

Sub CPrint (SOut As String)
    'Debug left off by intent
   Static cWritten As Long, iMsgCount As Long
   Incr iMsgCount
   SOut = Str$(iMsgCount) + " " + SOut
   If hConsole = 0 Then AllocConsole: hConsole = GetStdHandle(-11&)
   WriteConsole hConsole, ByCopy sOut + $CrLf, Len(sOut) + 2, cWritten, ByVal 0&
End Sub

Sub ClearConsole
   If Debug Then cPrint LCase$(FuncName$)
   Local hWrittenChars As Long, tConsoleInfo As CONSOLE_SCREEN_BUFFER_INFO
   GetConsoleScreenBufferInfo(hConsole, tConsoleInfo)
   FillConsoleOutputCharacter(hConsole, 32, tConsoleInfo.dwSize.x * tConsoleInfo.dwSize.y, Mak(Dword,0,0), hWrittenChars)
   SetConsoleCursorPosition(hConsole, Mak(Dword,0,0))
   Sleep 500   'time for cursor to move off ListView
End Sub

Sub BuildAcceleratorTable
   If Debug Then cPrint LCase$(FuncName$)
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(11)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help              : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDM_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDM_Debug             : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E      : ac(c).cmd   = %IDM_ClearConsole      : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N      : ac(c).cmd   = %IDT_New               : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O      : ac(c).cmd   = %IDT_Open              : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDT_Save              : Incr c

   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A      : ac(c).cmd   = %IDM_SelectAll         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L      : ac(c).cmd   = %IDM_ExtList           : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDM_Search            : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G      : ac(c).cmd   = %IDM_GoTo              : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDM_minToolbar        : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub GetExtList
    If Debug Then cPrint LCase$(FuncName$)
    Local x,y As Long, temp$
    ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
    CenterOverDialog(300,90,x,y)
    temp$ = InputBox$("Enter extension list:", "Extension List", ExtList,x,y)
    If Len(temp$) Then ExtList = temp$
End Sub

Function GetDroppedFileName(hDrop As Dword) As String
   If Debug Then cPrint LCase$(FuncName$)
   'David Gwillim July 2005
   Local fString As AsciiZ*%Max_Path, iCount As Long
   fString=Space$(%Max_Path)
   iCount = DragQueryFile(hDrop,0,fString,Len(fString)-1)  ' put FileName(0) into fString and get character count
   Function = Left$(fString,iCount)                           ' put Count chars into result string
End Function

Function GetLinkInfo(LinkPath As String ) As String
   If Debug Then cPrint LCase$(FuncName$)
   Local CLSID_ShellLink, IID_IShellLink As GUIDAPI
   Local CLSCTX_INPROC_SERVER, Flags, lResult As Dword
   Local FileData As WIN32_FIND_DATA
   Local IID_Persist As String * 16, pp, ppf, psl As Dword Ptr
   Local outvalue, TmpAsciiz As AsciiZ * %Max_Path
   Local TmpWide As AsciiZ * ( 2 * %Max_Path )
   Poke$ VarPtr(CLSID_ShellLink), Mkl$( &H00021401 ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   Poke$ VarPtr(IID_IShellLink), Mkl$( &H000214EE ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   IID_Persist = Mkl$( &H0000010B ) + Chr$( 0, 0, 0, 0, &HC0, 0, 0, 0, 0, 0, 0, &H46 )
   CLSCTX_INPROC_SERVER = 1
   If IsFalse( CoCreateInstance(CLSID_ShellLink, ByVal %NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, psl )) Then
      pp = @psl: Call Dword @pp Using Sub3( ByVal psl, IID_Persist, ppf ) To lResult
      TmpAsciiz = LinkPath
      MultiByteToWideChar %CP_ACP, 0, TmpAsciiz, %Max_Path, ByVal VarPtr(TmpWide), 2 * %Max_Path
      pp = @ppf + 20: Call Dword @pp Using Sub3( ByVal ppf, TmpWide, ByVal %TRUE )
      pp = @psl + 12: Call Dword @pp Using Sub5( ByVal psl, outvalue, ByVal %Max_Path, FileData, Flags )  'GetFilePath
      pp = @ppf + 8: Call Dword @pp Using Sub1( ByVal ppf )      'Release the persistant file
      pp = @psl + 8: Call Dword @pp Using Sub1( ByVal psl )      'Unbind the shell link object from the persistent file
      Function = outvalue
   End If
End Function

Sub OpenDroppedFile(fName$)
   If Debug Then cPrint LCase$(FuncName$)
   Local iResult As Long
   'save
   If Changes Then
      If AutoSave Then
          If Encrypt Then
              If ProvideSaveFilePassword Then
                  SaveContentToCFN : iResult = 1
              Else
                  MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " Drop File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Drop File")
              End If
          Else
              SaveContentToCFN : iResult = 1   'save change, then open file below
          End If
      Else
          Select Case MsgBoxX("Save changes?", %MB_YesNoCancel Or %MB_IconQuestion Or %MB_TaskModal, "Drop File")
             Case %IdYes
                 If Encrypt Then
                     If ProvideSaveFilePassword Then
                         SaveContentToCFN : iResult = 1  'save change, then open file below
                     Else
                          MsgBoxX("Changes cannot be saved (invalid password)" + $CrLf + $CrLf + " Drop File action cancelled!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Drop File")
                     End If
                 Else
                     SaveContentToCFN : iResult = 1  'save change, then open file below
                 End If
             Case %IdNo     : iResult = 1  'no save changes, then open file below
             Case %IdCancel : iResult = 0  'no further action
          End Select
      End If
   Else
      iResult = 1   'open file below
   End If
   'open
   If iResult Then
       'select file to open, ask for password, and open the file
       If Len(fName$) Then
           If ProvideOpenFilePassword(fName$) Then
               CFN = fName$ : LoadCFN      'user gave correct password
           Else
               MsgBoxX("Password not provided. Dropped file will not be opened!", %MB_Ok Or %MB_IconExclamation Or %MB_TaskModal, "Drop File")  'user did not give correct password
           End If
       End If
   End If
   Dialog Set Text hDlg, "gbEncrypt" + $ver + Space$(5) + CFN
   SetMenusAndToolbarButtons       'not always required, but doesn't hurt to run when not needed
End Sub

Sub DisplayFindDialog()
     If Debug Then cPrint LCase$(FuncName$)
     Local h As Long, w As Long
     Dialog Get Client hDlg To h,w
     Dialog New Pixels, hDlg, "Find & Replace", 100, 80, 310, 95, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
     Dialog Set Icon hSearch, "aaa"
     Control Add Label, hSearch, 1000, "Find This:", 5, 10, 60, 20
     Control Add Label, hSearch, 1000, "Replace With:", 5, 40, 70, 20
     Control Add TextBox, hSearch, %IDC_SearchTerm, SearchTerm, 80, 10, 150, 20
     Control Add Button, hSearch, %IDC_Search, "Find", 240, 10, 60, 25
     Control Add TextBox, hSearch, %IDC_ReplaceTerm, ReplaceTerm, 80, 40, 150, 20
     Control Add Button, hSearch, %IDC_Replace, "Replace", 240, 40, 60, 20
     Control Add Option, hSearch, %IDC_Up, "Up",80,70,40,20, %WS_Group Or %WS_TabStop
     Control Add Option, hSearch, %IDC_Down, "Down", 120,70,50,20
     Control Add CheckBox, hSearch, %IDC_MatchCase, "Match Case", 180,70,100,20, %WS_Group Or %WS_TabStop
     Control Set Option hSearch, %IDC_Down, %IDC_Up, %IDC_Down
     fDlgShown = 1
     Dialog Show Modeless hSearch Call SearchProc()
     Do                           'because we want to be able to edit main
        Dialog DoEvents           'text while search dialog is visible
     Loop Until fDlgShown = 0
End Sub

CallBack Function SearchProc() As Long
    Select Case Cb.Msg
      Case %IdCancel           : fDlgShown = 0 : Dialog End hSearch
      Case %WM_Destroy         : fDlgShown = 0
      Case %WM_Command
          Select Case Cb.Ctl
             Case %IdCancel    : Dialog End hSearch
             Case %IDC_Search  : FindSearchTerm  'starting at cursor location
             Case %IDC_Replace
                 Control Send hDlg, %IDC_Content, %EM_ReplaceSel, %True, StrPtr(ReplaceTerm)
                 FindSearchTerm
          End Select
    End Select
End Function

Sub FindSearchTerm
   If Debug Then cPrint LCase$(FuncName$)
   Local text$, sTerm$, MatchCase, SearchUp As Long
   Local apiSearchStart, apiSearchEnd, pbSearchStart, pbSearchEnd As Long
   'get search parameters
   Control Get Text hSearch, %IDC_SearchTerm To SearchTerm : If SearchTerm = "" Then Beep : Exit Sub
   Control Get Text hDlg, %IDC_Content To text$
   Control Get Check hSearch, %IDC_MatchCase To MatchCase
   Control Get Check hSearch, %IDC_Up To SearchUp
   If MatchCase = 1 Then sTerm$ = SearchTerm
   If MatchCase = 0 Then sTerm$ = LCase$(SearchTerm) : text$ = LCase$(text$)

   Control Send hDlg, %IDC_Content, %EM_GetSel, VarPtr(apiSearchStart), VarPtr(apiSearchEnd)  'get start/end pos
   If SearchUp = 1 Then  'reverse search
       pbSearchStart = InStr(-1*(Len(text$)-apiSearchStart), text$, sTerm$)
       If pbSearchStart Then Control Send hDlg, %IDC_Content, %EM_SetSel, pbSearchStart-1, pbSearchStart+Len(SearchTerm)-1
   Else                 'forward search
       pbSearchStart = InStr(apiSearchStart+IIf(apiSearchStart=apiSearchEnd,1,2), text$, sTerm$)  'forward search
       If pbSearchStart Then Control Send hDlg, %IDC_Content, %EM_SetSel, pbSearchStart-1, pbSearchStart+Len(SearchTerm)-1
   End If
   Control Send hDlg, %IDC_Content, %EM_ScrollCaret, 0, 0
   If pbSearchStart = 0 Then Beep
End Sub

Sub SelectContentFont
   If Debug Then cPrint LCase$(FuncName$)
   Local Flags As Long, fName$, fSize,fStyle As Long
   Flags = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoSimulations Or %CF_NoScriptSel
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontStyle, Flags To fName$, fSize, fStyle
   If Len(fName$) Then FontName = fName$ : FontSize = fSize : FontStyle = fStyle : CreateContentFont
End Sub

Sub CreateContentFont
   Control Set Font hDlg, %IDC_Content, 0
   Font End hFont
   Font New FontName, FontSize, FontStyle To hFont
   Control Set Font hDlg, %IDC_Content, hFont
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As AsciiZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub SortContent(direction$)
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$
   Control Get Text hDlg, %IDC_Content To temp$    'put all lines in an array
   Dim D(ParseCount(temp$,$CrLf)-1) As String
   Parse temp$, D(), $CrLf
   If direction$ = "A" Then
       Array Sort D(), Ascend
   Else
       Array Sort D(), Descend
   End If
   Control Set Text hDlg, %IDC_Content, Join$(D(),$CrLf)
End Sub

Sub ContentSummary
   If Debug Then cPrint LCase$(FuncName$)
   Dim T() As String
   Local iLineFeeds As Long, iTotalChars As Long, temp$, i As Long
   Local iLong As Long, iShort As Long, iLines As Long

   Control Get Text hDlg, %IDC_Content To temp$
   If Len(temp$) = 0 Then
       MsgBoxX "Statistics:" & $CrLf & $CrLf & "None - file is empty", %MB_Ok + %MB_IconExclamation,"Content Summary"
       Exit Sub
   End If
   iLines = ParseCount(temp$, $CrLf)
   Dim T(iLines) : Parse temp$, T(), $CrLf

   'look for longest/shortest lines
   iLong = 0 :  iShort = 99999999
   For i = 0 To UBound(T)
       If iLong < Len(T(i)) Then iLong = Len(T(i))
       If iShort > Len(T(i)) Then iShort = Len(T(i))
   Next i

   iLineFeeds = Tally(temp$, $CrLf)
   iTotalChars = Len(temp$)

   'set message
   temp$ = "Characters: " & Str$(iTotalChars) & $CrLf
   temp$ = temp$ & "Number lines: " & Str$(iLines) & $CrLf  & $CrLf
   temp$ = temp$ & "Shortest Line: " & Str$(iShort) & $CrLf
   temp$ = temp$ & "Longest line: " & Str$(iLong) & $CrLf
   temp$ = temp$ & "Average Line Length: " & Str$(Int(iTotalChars / iLines)) & $CrLf & $CrLf

   MsgBoxX temp$, %MB_Ok + %MB_IconInformation, "Content Summary"
End Sub

Sub DisplayMatchingLines
   If Debug Then cPrint LCase$(FuncName$)
   Local temp$, i As Long

   Control Get Text hDlg, %IDC_Content To temp$
   temp$ = LCase$(temp$)
   Dim rLines(ParseCount(temp$,$CrLf)-1) As String   'rLines has original content
   Parse temp$, rLines(),$CrLf

   Open Exe.Path$ + "matchinglines.txt" For Output As #1
   For i = 0 To UBound(rLines)
       If InStr(rLines(i),LCase$(SearchTerm)) Then Print #1, rLInes(i)
   Next i
   Close #1

   i = Shell ("Notepad " + Exe.Path$ + "matchinglines.txt", 1)  'opens Notepad, does not wait for it to close
End Sub

Sub Redo
    Control Send hDlg, %IDC_Content, %EM_Undo, 0, 0
End Sub

Sub Undo
    Control Send hDlg, %IDC_Content, %EM_Undo, 0, 0
End Sub

Function SelectColor(startcolor&) As Long    'works on pControl
   If Debug Then cPrint LCase$(FuncName$)
   Local ColorResult&
   Display Color hDlg, 200, 200, startcolor&, CustomColorList ,0 To ColorResult&
   If ColorResult& = -1 Then Function = startcolor& Else Function = ColorResult&
End Function

Function AddLineNumbers As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i,iCount As Long, temp$
    Control Get Text hDlg, %IDC_Content To temp$
    Dim cLines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, cLines(), $CrLf
    For i = 0 To UBound(cLines)
       Incr iCount
       cLines(i) = Format$(iCount,"000000") + "   " + cLines(i)
    Next i
    Control Set Text hDlg, %IDC_Content, Join$(cLines(),$CrLf)
    Changes = 1 : SetMenusAndToolbarButtons
End Function

Function RemoveLineNumbers As String
    If Debug Then cPrint LCase$(FuncName$)
    Local i As Long, temp$
    Control Get Text hDlg, %IDC_Content To temp$
    Dim cLines(ParseCount(temp$,$CrLf)-1) As String
    Parse temp$, cLines(), $CrLf
    For i = 0 To UBound(cLines)
        cLines(i) = Mid$(cLines(i), 10)
    Next i
    Control Set Text hDlg, %IDC_Content, Join$(cLines(),$CrLf)
    Changes = 1 : SetMenusAndToolbarButtons
End Function

Sub GoToLine
   Local i,x,y,lMax,lTop,iSelect As Long, temp$
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   CenterOverDialog(300,90,x,y)
   temp$ = InputBox$("Go to line: ", "Go To Line", "",x,y)
   If Len(temp$) Then
       iSelect = Val(temp$)-1
       If iSelect < 0  Then Exit Sub
       Control Send hDlg, %IDC_Content, %EM_GetLineCount, 0, 0 To lMax
       If iSelect > lMax Then Exit Sub
       Control Send hDlg, %IDC_Content, %EM_GetFirstVisibleLine,0,0 To lTop
       If lTop > iSelect Then
           For i = 1 To Abs(lTop-iSelect) : Control Send hDlg, %IDC_Content, %EM_Scroll, %SB_LineUp, 0 : Next i
       Else
           For i = 1 To Abs(lTop-iSelect) : Control Send hDlg, %IDC_Content, %EM_Scroll, %SB_LineDown, 0 : Next i
       End If
   End If
End Sub
